package Control;

import Model.Application;
import Model.Type;
import View.View;

public class IdleThread extends Thread {
	private long time;
	private Application app;
	private View myView;
	private boolean canRun;

	public boolean isCanRun() {
		return canRun;
	}

	public void setCanRun(boolean canRun) {
		this.canRun = canRun;
	}

	public View getMyView() {
		return myView;
	}

	public void setMyView(View v) {
		this.myView = v;
	}

	public IdleThread(Application a) {
		this.setPriority(NORM_PRIORITY);
		time = 0;
		app = a;
		myView = null;
	}

	public void run() {
		while (true) {
			long ellapsedTimeMillis = System.currentTimeMillis() - time;
			time = System.currentTimeMillis();
			try {
				sleep(10);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			if(canRun) {
				synchronized (this) {
					//("simulate "+ellapsedTimeMillis+" ms");
					app.getActualLevel().move(Type.FigureA,
							Controller.calculateDirection(Type.FigureA), null);
					app.getActualLevel().move(Type.FigureB,
							Controller.calculateDirection(Type.FigureB), null);
					app.simulateWorld((int) ellapsedTimeMillis, null);
					myView.repaint();
					//("simulated");
				}
			}
		}
	}
}
