package Model;

import java.awt.Point;
import java.io.PrintWriter;

/**
 * EmptyTile osztly.
 * 
 * Olyan mozgsra kpes csempe, mely nem tartalmaz terepet. Benne bbu nem
 * lehet.
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public class EmptyTile extends Tile {
	/**
	 * EmptyTile konstruktora. Ltrehoz egy j res csempt a
	 * megadott pontba adott szlessggel s magassggal, belltja a sajt
	 * szintjt.
	 * 
	 * @param myLevel
	 *            az res csempe sajt szintje
	 */
	public EmptyTile(Level myLevel, Point center, int h, int w) {
		super(myLevel, center, h, w);
	}

	public EmptyTile(Level myLevel, Point point) {
		super(myLevel, point);
	}

	/**
	 * Az res csempe mozgatst vgz fggvny. Ha van abba az irnyba msik
	 * csempe, amerre mozgatni akarjuk, akkor megcserli a kt csempt.
	 * 
	 * @param dir
	 *            a mozgs irnya
	 */
	public void move(Direction dir, PrintWriter pw) {
		//Irny trsa szomszdkrshez
		Direction dir2 = new Direction();
		if(dir.getAngle() == 0)
			dir2.setAngle(180);
		else if(dir.getAngle() == 90)
			dir2.setAngle(270);
		else if(dir.getAngle() == 180)
			dir2.setAngle(0);
		else if(dir.getAngle() == 270)
			dir2.setAngle(90);
		
		// Lekrdezzk a szomszdot
		FullTile t = myLevel.getNeighbour(dir2, this.getTileIndex());
		// Ha van szomszd, akkor mozoghatunk
		if (t != null) {
			this.setTileIndex(t.changePosition(this.getTileIndex()));
		} else {
			if(pw!=null)
			pw.println("Az adott iranyba nem mozdulhatnak a csempek. A csempek jelenlegi allasa:");
		}
	}
}
