package Model;

import java.awt.Point;
import java.io.*;
import java.util.*;

/**
 * A Frame osztly.
 * 
 * A csempk kerett reprezentl osztly. Meg tudja mondani, hogy kt csempe
 * terepe megegyezik-e a megadott szlen. A koordintk transzformlst vgzi.
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public class Frame {
	/**
	 * A terep szlt reprezentl pontok. Ebbl ll a teli csempe kerete.
	 */
	private ArrayList<Point> framePoints;

	/** Frame konstruktora. Ltrehoz egy j keretet. */
	public Frame() {
		framePoints = new ArrayList<Point>();
	}

	/**
	 * Megnzi, hogy a paramterknt kapott koordintn keret van-e.
	 * 
	 * @param coord
	 *            a koordinta, ahol vizsglni akarunk
	 * @return igaz, ha van keret az adott koordintn
	 */
	public boolean checkFrame(Point coord) {
		if (coord.x > 495 || coord.x < 5 || coord.y > 382 || coord.y < 18) {
			return true;
		}
		return false;
	}

	/**
	 * Referencit ad a keret kontrollpontjait tartalmaz tmbre.
	 * 
	 * @return a keret kontrollpontjait tartalmaz tmb
	 */
	public ArrayList<Point> getFramePoints() {
		return framePoints;
	}

	/**
	 * Megvizsglja, hogy egyezik-e a paramterknt kapott kerettel.
	 * 
	 * @param f
	 *            the f
	 * @return igaz, ha egyeznek
	 */
	public boolean match(Frame f) {
		if (framePoints.size() != f.framePoints.size())
			return false;

		int points = framePoints.size();
		int goodPoints = 0;

		for (int i = 0; i < framePoints.size(); i++) {
			// NEM SORRENDERZEKENY VIZSGALAT
			for (int j = 0; j < f.framePoints.size(); j++) {
				if (framePoints.get(i).equals(f.framePoints.get(j))) {
					goodPoints++;
				}
			}
		}

		if (points == goodPoints) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Hozzad a kerethez egy pontot.
	 * 
	 * @param p
	 *            A keretnek belltand pont.
	 */
	void setFramePoint(Point p) {
		framePoints.add(p);
	}

}
