package Model;

import java.awt.Point;

/**
 * Tile osztly.
 * 
 * Ezzel az absztrakt osztllyal lehetsges a FullTile-ok s EmptyTile-ok egy 
 * tmbben trolsa.
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public class Tile {
	/** A csempe indexe. */
	private Point tileIndex;

	/** A csempe magassga. */
	private int height;

	/** A csempe sajt szintje. */
	protected Level myLevel;

	/** A csempe szlessge. */
	private int width;

	/**
	 * Tile konstruktora. Ltrehoz egy j csempt.
	 * 
	 * @param l
	 *            the l
	 */
	public Tile(Level l, Point i, int h, int w) {
		tileIndex = i;
		height = h;
		myLevel = l;
		width = h;		
	}
	
	/**
	 * Instantiates a new tile.
	 *
	 * @param l the l
	 * @param i the i
	 */
	public Tile(Level l, Point i) {
		tileIndex = i;
		height = 400;
		myLevel = l;
		width = 500;		
	}

	/**
	 * Megadja a csempe koordintjt.
	 * 
	 * @return a csempe koordintja
	 */
	public Point getTileIndex() {
		return tileIndex;
	}

	/**
	 * Megadja a csempe magassga.
	 * 
	 * @return a csempe magassga
	 */
	public int getHeight() {
		return height;
	}

	/**
	 * Megadja a csempe szlessgt.
	 * 
	 * @return a csempe szlesge.
	 */
	public int getWidth() {
		return width;
	}

	/**
	 * Belltja a csempe koordintjt.
	 * 
	 * @param i
	 *            a csempe belltand, j indexe.
	 */
	public void setTileIndex(Point i) {
		this.tileIndex = i;
	}
}
