package View;

import javax.imageio.ImageIO;
import javax.swing.*;

import Model.Exit;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

// TODO: Auto-generated Javadoc
/**
 * The Class ExitView.
 */
public class ExitView implements IPaintable {

	/** The bi. */
	private BufferedImage bi;

	/** The my exit. */
	private Exit myExit;

	/** The my view. */
	private View myView;

	/**
	 * Instantiates a new exit view.
	 * 
	 * @param e
	 *            the e
	 * @param v
	 *            the v
	 */
	public ExitView(Exit e, View v) {
		try {
			bi = ImageIO.read(new File("exit.png"));
		} catch (IOException ex) {
			System.out.println("Exit image error");
		}
		myExit = e;
		myView = v;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see View.IPaintable#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		int dimensionX = myView.getMyLevel().getX();
		int dimensionY = myView.getMyLevel().getY();
		Point coord = myExit.transformToMatrixCoord();

		// kiszmoljuk a tartalmaz csempe bal fels sarkt
		int xBound = (800 / dimensionY * myExit.getMyTile().getTileIndex().y)
				- (800 / dimensionY);
		int yBound = (600 / dimensionX * myExit.getMyTile().getTileIndex().x)
				- (600 / dimensionX);
		// kijrat bal fels sarknak belltsa
		coord.x *= myView.getScale();
		coord.y *= myView.getScale();
		coord.translate(xBound - (int) (bi.getWidth() / 2 * myView.getScale()), yBound
				- (int) (bi.getHeight() / 2 * myView.getScale()));
		// scale tllts
		g2d.scale(myView.getScale(), myView.getScale());
		g2d.drawImage(bi, (int) (coord.x / myView.getScale()),
				(int) (coord.y / myView.getScale()), null);

		// scale visszallts
		g2d.scale(1 / myView.getScale(), 1 / myView.getScale());
	}

}
