package View;

import javax.imageio.ImageIO;
import javax.swing.*;

import Model.Figure;
import Model.Type;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

// TODO: Auto-generated Javadoc
/**
 * The Class FigureView.
 */
public class FigureView implements IPaintable {

	/** The right. */
	private BufferedImage stop, left, right;

	/** The my figure. */
	private Figure myFigure;

	/** The my view. */
	private View myView;

	/**
	 * Instantiates a new figure view.
	 * 
	 * @param f
	 *            the f
	 * @param v
	 *            the v
	 * @param t
	 *            the t
	 */
	public FigureView(Figure f, View v, Type t) {
		try {
			if (t == Type.FigureA) {
				stop = ImageIO.read(new File("figureA_stop.png"));
				left = ImageIO.read(new File("figureA_go_left.png"));
				right = ImageIO.read(new File("figureA_go_right.png"));
			} else if (t == Type.FigureB) {
				stop = ImageIO.read(new File("figureB_stop.png"));
				left = ImageIO.read(new File("figureB_go_left.png"));
				right = ImageIO.read(new File("figureB_go_right.png"));
			} else
				throw new IOException();
		} catch (IOException ex) {
			System.out.println("Figure image error");
		}
		myFigure = f;
		myView = v;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see View.IPaintable#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		int dimensionX = myView.getMyLevel().getX();
		int dimensionY = myView.getMyLevel().getY();
		Point coord = myFigure.transformToMatrixCoord();

		// kiszmoljuk a tartalmaz csempe bal fels sarkt
		int xBound = (800 / dimensionY * myFigure.getMyTile().getTileIndex().y)
				- (800 / dimensionY);
		int yBound = (600 / dimensionX * myFigure.getMyTile().getTileIndex().x)
				- (600 / dimensionX);
		// scale tllts
		g2d.scale(myView.getScale(), myView.getScale());

		// Ha a bbu ll
		if ((int) myFigure.getOldDirection().getX() == 0) {
			// bbu bal fels sarknak belltsa
			coord.x *= myView.getScale();
			coord.y *= myView.getScale();
			coord.translate(xBound - (int) (stop.getWidth() / 2 * myView.getScale()),
					yBound - (int) (stop.getHeight() / 2 * myView.getScale()));
			g2d.drawImage(stop, (int) (coord.x / myView.getScale()),
					(int) (coord.y / myView.getScale()), null);
		}

		// Ha a bbu jobbra halad
		else if (myFigure.getOldDirection().getX() > 0
				&& myFigure.getOldDirection().getLength() > 0) {
			// bbu bal fels sarknak belltsa s rajzols
			coord.x *= myView.getScale();
			coord.y *= myView.getScale();
			coord.translate(xBound - (int) (right.getWidth() / 2 * myView.getScale()),
					yBound - (int) (right.getHeight() / 2 * myView.getScale()));
			g2d.drawImage(right, (int) (coord.x / myView.getScale()),
					(int) (coord.y / myView.getScale()), null);
		}

		// Ha a bbu balra halad
		else if (myFigure.getOldDirection().getX() < 0
				&& myFigure.getOldDirection().getLength() > 0) {
			// bbu bal fels sarknak belltsa s rajzols
			coord.x *= myView.getScale();
			coord.y *= myView.getScale();
			coord.translate(xBound - (int) (left.getWidth() / 2 * myView.getScale()),
					yBound - (int) (left.getHeight() / 2 * myView.getScale()));
			g2d.drawImage(left, (int) (coord.x / myView.getScale()),
					(int) (coord.y / myView.getScale()), null);
		}

		// scale visszallts
		g2d.scale(1 / myView.getScale(), 1 / myView.getScale());
	}

}
