package View;

import javax.imageio.ImageIO;
import javax.swing.*;

import Model.Key;
import Model.Type;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

// TODO: Auto-generated Javadoc
/**
 * The Class KeyView.
 */
public class KeyView implements IPaintable {
	
	/** The found. */
	private BufferedImage found;
	
	/** The not found. */
	private BufferedImage notFound;
	
	/** The my key. */
	private Key myKey;
	
	/** The my view. */
	private View myView;

	/**
	 * Instantiates a new key view.
	 *
	 * @param k the k
	 * @param v the v
	 */
	public KeyView(Key k, View v) {
		try {
			found = ImageIO.read(new File("key_pickedup.png"));
			notFound = ImageIO.read(new File("key.png"));
		} catch (IOException ex) {
			System.out.println("Key image error");
		}
		myKey = k;
		myView = v;
	}

	/* (non-Javadoc)
	 * @see View.IPaintable#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		int dimensionX = myView.getMyLevel().getX();
		int dimensionY = myView.getMyLevel().getY();
		Point coord = myKey.transformToMatrixCoord();

		// kiszmoljuk a tartalmaz csempe bal fels sarkt
		int xBound = (800 / dimensionY * myKey.getMyTile().getTileIndex().y)
				- (800 / dimensionY);
		int yBound = (600 / dimensionX * myKey.getMyTile().getTileIndex().x)
				- (600 / dimensionX);
		// scale llts
		g2d.scale(myView.getScale(), myView.getScale());
		if (myKey.isPickedUp()) {
			// kulcs bal fels sarknak belltsa s rajzols
			coord.x *= myView.getScale();
			coord.y *= myView.getScale();
			coord.translate(xBound - (int) (found.getWidth() / 2 * myView.getScale()), yBound
					- (int) (found.getHeight() / 2 * myView.getScale()));
			g2d.drawImage(found, (int) (coord.x / myView.getScale()),
					(int) (coord.y / myView.getScale()), null);
		} else {
			// kulcs bal fels sarknak belltsa s rajzols
			coord.x *= myView.getScale();
			coord.y *= myView.getScale();
			coord.translate(xBound - (int) (notFound.getWidth() / 2 * myView.getScale()), yBound
					- (int) (notFound.getHeight() / 2 * myView.getScale()));
			g2d.drawImage(notFound, (int) (coord.x / myView.getScale()),
					(int) (coord.y / myView.getScale()), null);
		}
		// scale visszallts
		g2d.scale(1 / myView.getScale(), 1 / myView.getScale());
	}
}
